Panda3D

Public Types | Public Member Functions | Friends | List of all members
ConstPointerToArray< Element > Class Template Reference

Similar to PointerToArray, except that its contents may not be modified. More...

`#include "pointerToArray.h"`

Inheritance diagram for ConstPointerToArray< Element >:

## Public Types
typedef pvector< Element >::const_iterator | const_iterator
typedef pvector< Element >::const_reference | const_reference
typedef pvector< Element >::const_reverse_iterator | const_reverse_iterator
typedef pvector< Element >::difference_type | difference_type
typedef pvector< Element >::const_iterator | iterator
typedef pvector< Element >::const_reference | reference
typedef pvector< Element >::const_reverse_iterator | reverse_iterator
typedef pvector< Element >::size_type | size_type
typedef PointerToArrayBase< Element >::To | To
typedef pvector< Element >::value_type | value_type
Public Types inherited from PointerToArrayBase< Element >
typedef PointerToBase< ReferenceCountedVector< Element > >::To | To
Public Types inherited from PointerToBase< ReferenceCountedVector< Element > >
typedef ReferenceCountedVector< Element > | To

## Public Member Functions
| ConstPointerToArray (const ConstPointerToArray< Element > &copy)
| ConstPointerToArray (const Element *begin, const Element *end, TypeHandle type_handle=get_type_handle(Element))
| Initializes a ConstPointerToArray by copying existing elements. More...
| ConstPointerToArray (const PointerToArray< Element > &copy)
| ConstPointerToArray (ConstPointerToArray< Element > &&from) noexcept
| ConstPointerToArray (PointerToArray< Element > &&from) noexcept
| ConstPointerToArray (pvector< Element > &&from, TypeHandle type_handle=get_type_handle(Element))
| Initializes the PTA from a vector. More...
| ConstPointerToArray (TypeHandle type_handle=get_type_handle(Element))
reference | back () const
iterator | begin () const
size_type | capacity () const
PointerToArray< Element > | cast_non_const () const
| Casts away the constness of the CPTA(Element), and returns an equivalent PTA(Element). More...
void | clear ()
| To empty the PTA, use the clear() method, since assignment to NULL is problematic (given the ambiguity of the pointer type of NULL). More...
size_t | count (const Element &) const
| Counts the frequency at which the given element occurs in the vector. More...
bool | empty () const
iterator | end () const
reference | front () const
std::string | get_data () const
| This method exists mainly to access the data of the array easily from a high-level language such as Python. More...
const Element & | get_element (size_type n) const
| This method exists mainly to access the elements of the array easily from a high-level language such as Python, especially on Windows, where the above index element accessor methods can't be defined because of a confusion with the pointer typecast operator. More...
int | get_node_ref_count () const
| Returns the node_ref of the underlying vector. More...
int | get_ref_count () const
| Returns the reference count of the underlying vector. More...
std::string | get_subdata (size_type n, size_type count) const
| This method exists mainly to access the data of the array easily from a high-level language such as Python. More...
size_type | max_size () const
void | node_ref () const
| Increments the node_ref of the underlying vector. More...
bool | node_unref () const
| Decrements the node_ref of the underlying vector. More...
| operator const Element * () const
| The pointer typecast operator is convenient for maintaining the fiction that we actually have a C-style array. More...
ConstPointerToArray< Element > & | operator= (const ConstPointerToArray< Element > &copy)
ConstPointerToArray< Element > & | operator= (const PointerToArray< Element > &copy)
ConstPointerToArray< Element > & | operator= (ConstPointerToArray< Element > &&from) noexcept
ConstPointerToArray< Element > & | operator= (PointerToArray< Element > &&from) noexcept
ConstPointerToArray< Element > & | operator= (ReferenceCountedVector< Element > *ptr)
reference | operator[] (int n) const
reference | operator[] (size_type n) const
const Element * | p () const
| Function p() is similar to the function from ConstPointerTo. More...
ConstPointerToArray< Element >::reverse_iterator | rbegin () const
void | ref () const
| Increments the reference count of the underlying vector. More...
ConstPointerToArray< Element >::reverse_iterator | rend () const
size_type | size () const
bool | unref () const
| Decrements the reference count of the underlying vector. More...
const pvector< Element > & | v () const
| To access the vector itself, for more direct fiddling with some of the vector's esoteric functionality. More...
const ReferenceCountedVector< Element > * | v0 () const
| To access the internal ReferenceCountedVector object, for very low-level fiddling. More...
Public Member Functions inherited from PointerToBase< ReferenceCountedVector< Element > >
void | clear ()
| A convenient way to set the PointerTo object to NULL. More...
void | output (std::ostream &out) const
| A handy function to output PointerTo's as a hex pointer followed by a reference count. More...
Public Member Functions inherited from PointerToVoid
size_t | get_hash () const
constexpr bool | is_null () const
| Returns true if the PointerTo is a NULL pointer, false otherwise. More...
bool | operator!= (const PointerToVoid &other) const
bool | operator< (const PointerToVoid &other) const
bool | operator< (const void *other) const
bool | operator== (const PointerToVoid &other) const
void | swap (PointerToVoid &other) noexcept
| Swaps the contents of this PointerTo with the other, without touching the reference counts. More...
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Friends
class | PointerToArray< Element >

## Detailed Description

### template<class Element>
class ConstPointerToArray< Element >

Similar to PointerToArray, except that its contents may not be modified.

Definition at line 252 of file pointerToArray.h.

## Constructor & Destructor Documentation

## ◆ ConstPointerToArray() [1/2]

template<class Element >

ConstPointerToArray< Element >::ConstPointerToArray | ( | const Element * | begin,
|  | const Element * | end,
|  | TypeHandle | type_handle = `get_type_handle(Element)`
| ) |  |
| inline

Initializes a ConstPointerToArray by copying existing elements.

Definition at line 665 of file pointerToArray.I.

## ◆ ConstPointerToArray() [2/2]

template<class Element >

ConstPointerToArray< Element >::ConstPointerToArray | ( | pvector< Element > && | from,
|  | TypeHandle | type_handle = `get_type_handle(Element)`
| ) |  |
| inline explicit

Initializes the PTA from a vector.

Definition at line 720 of file pointerToArray.I.

## Member Function Documentation

## ◆ cast_non_const()

template<class Element >

PointerToArray< Element > ConstPointerToArray< Element >::cast_non_const
| inline

Casts away the constness of the CPTA(Element), and returns an equivalent PTA(Element).

Definition at line 926 of file pointerToArray.I.

## ◆ clear()

template<class Element >

void ConstPointerToArray< Element >::clear
| inline

To empty the PTA, use the clear() method, since assignment to NULL is problematic (given the ambiguity of the pointer type of NULL).

Definition at line 1108 of file pointerToArray.I.

## ◆ count()

template<class Element >

size_t ConstPointerToArray< Element >::count | ( | const Element & | value | ) | const
| inline

Counts the frequency at which the given element occurs in the vector.

Definition at line 1040 of file pointerToArray.I.

## ◆ get_data()

template<class Element >

std::string ConstPointerToArray< Element >::get_data
| inline

This method exists mainly to access the data of the array easily from a high-level language such as Python.

It returns the entire contents of the vector as a block of raw data in a string.

Definition at line 953 of file pointerToArray.I.

## ◆ get_element()

template<class Element >

const Element & ConstPointerToArray< Element >::get_element | ( | size_type | n | ) | const
| inline

This method exists mainly to access the elements of the array easily from a high-level language such as Python, especially on Windows, where the above index element accessor methods can't be defined because of a confusion with the pointer typecast operator.

Definition at line 940 of file pointerToArray.I.

## ◆ get_node_ref_count()

template<class Element >

int ConstPointerToArray< Element >::get_node_ref_count
| inline

Returns the node_ref of the underlying vector.

Definition at line 1009 of file pointerToArray.I.

## ◆ get_ref_count()

template<class Element >

int ConstPointerToArray< Element >::get_ref_count
| inline

Returns the reference count of the underlying vector.

Definition at line 978 of file pointerToArray.I.

## ◆ get_subdata()

template<class Element >

std::string ConstPointerToArray< Element >::get_subdata | ( | size_type | n,
|  | size_type | count
| ) |  | const
| inline

This method exists mainly to access the data of the array easily from a high-level language such as Python.

It returns the contents of a portion of the vector–from element (n) through element (n + count - 1)–as a block of raw data in a string.

Definition at line 966 of file pointerToArray.I.

## ◆ node_ref()

template<class Element >

void ConstPointerToArray< Element >::node_ref
| inline

Increments the node_ref of the underlying vector.

Definition at line 1018 of file pointerToArray.I.

## ◆ node_unref()

template<class Element >

bool ConstPointerToArray< Element >::node_unref
| inline

Decrements the node_ref of the underlying vector.

Definition at line 1030 of file pointerToArray.I.

## ◆ operator const Element *()

template<class Element >

ConstPointerToArray< Element >::operator const Element *
| inline

The pointer typecast operator is convenient for maintaining the fiction that we actually have a C-style array.

It returns the address of the first element in the array, unless the pointer is unassigned, in which case it returns NULL.

Definition at line 881 of file pointerToArray.I.

## ◆ p()

template<class Element >

const Element * ConstPointerToArray< Element >::p
| inline

Function p() is similar to the function from ConstPointerTo.

It does the same thing: it returns the same thing as the typecast operator, above.

Definition at line 892 of file pointerToArray.I.

## ◆ ref()

template<class Element >

void ConstPointerToArray< Element >::ref
| inline

Increments the reference count of the underlying vector.

Definition at line 987 of file pointerToArray.I.

## ◆ unref()

template<class Element >

bool ConstPointerToArray< Element >::unref
| inline

Decrements the reference count of the underlying vector.

Definition at line 999 of file pointerToArray.I.

## ◆ v()

template<class Element >

const pvector< Element > & ConstPointerToArray< Element >::v
| inline

To access the vector itself, for more direct fiddling with some of the vector's esoteric functionality.

Definition at line 903 of file pointerToArray.I.

## ◆ v0()

template<class Element >

const ReferenceCountedVector< Element > * ConstPointerToArray< Element >::v0
| inline

To access the internal ReferenceCountedVector object, for very low-level fiddling.

Know what you are doing!

Definition at line 916 of file pointerToArray.I.

The documentation for this class was generated from the following files:

- panda/src/express/pointerToArray.h
- panda/src/express/pointerToArray.I